function C = conv_f(f,g)
% Convolution of two 1D signals
%
% Usage:
%   C = conv_f_1(f,g);
%
% Convolution of two 1D signals f and g
% uses Fourier transform to perform the convolution.
% f and g should be periodic signals of length 2^N 
%
% Inputs:
%   f - 1D signal
%   g - 1D signal
% Outputs:
%   C - convolution of the two signals
%
% See also CORR_F

Ff = fft(f);
Fg = fft(g);

C = ifft(Ff.*Fg);

% Matlab dependencies:
% Created 2/6/2006 Jori