function sigout = fft2downsample(sig,m,n)
% Downsample a signal by truncating in Fourier space
%
% Usage:
%   sigout = fft2downsample(sig,m,n);
%
% Downsample a signal by truncating in Fourier space
% Works for even length 2D signals
%
% See also fftdownsample

[M,N] = size(sig); % original signal size [rows,columns]

Fsig = fft2(sig);

Fsig(:,n/2+1:end-n/2) = []; % eliminate column elements at high wavenumber
Fsig(m/2+1:end-m/2,:) = []; % eliminate row elements at high wavenumber

Fsig = Fsig*(n/N)*(m/M); % renormalize to preserve mean


% ensure that the signal remains real, set highest 
% wavenumber coefficients to zero
Fsig(m/2+1,:)=0;Fsig(:,n/2+1)=0;


sigout = ifft2(Fsig); % return the filtered signal out

% Created 7/4/2006 Jori