function usig = fftupsample(sig,n)
% Up sample a 1D signal by FFT
%
% Usage:
%   usig = fftupsample(sig,n);
%
% Up sample a function by FFT
% (zero pad in Fourier space and inverse transform)
%
% Inputs:
%   sig - signal to be resampled
%   N - resampling size of signal
% Outputs:
%   usig - upsampled signal
%
% See also: fft2upsample, fftdownsample, fft2downsample,
%   fftzeropad, fft2zeropad

% TODO: clean code

N = size(sig,1); % original length

[sig, nshifts] = shiftdim(sig);

Fsig = fft(sig); % Fourier transform

[zpdFsig,k] = fftzeropad(Fsig,n); % zeropad in Fourier space


zpdFsig = zpdFsig*(n/N); % renormalize to preserve mean

usig = ifft(zpdFsig,'symmetric'); % up sampled signal

usig = shiftdim(usig, -nshifts);

% Created 8/23/2006 Jori