function [fs] = filt_lin_f(f,o)
% Linear Fourier filtering of a signal
%
% Low pass filter
%
% Usage:
%   fs = filt_lin_f(f,o)
%
% Inputs:
%   f - the input signal
%   o - the cutoff frequency or band of frequencies
%          (integer wavenumber)
% Output:
%   fs - the filtered signal
%

% TODO: improve help
% Updates: 4/11/2007 changed fft -> fft2 to handle both vectors and
% matrices, changed length(f) -> size(f), added conditional test and
% fmodes2

% Fourier transform of the signal
Ff = fft2(f);


% Fourier frequencies
if (isvector(f))
    N = length(f);
    k = fmodes(N);
else
    N = size(f);
   [kx,ky] = fmodes2(N);
    k = sqrt(kx.^2 + ky.^2);
end %if

% indices of Frequencies to filter out
in_o = abs(k)>o;

Ff(in_o) = 0;

% invert the transform to obtain the filtered signal
fs = ifft2(Ff);

% Matlab dependencies: fft, ifft, length
% Created 2/6/2006 Jori