function [fs] = filt_nonlin_f(f,th)
% Nonlinear Fourier filtering of a signal
%
% Usage:
%   fs = filt_nonlin_f(f,th);
%
% Inputs:
%   f - the input signal
%   th - threshold for the magnitude of Fourier coefficient
%
% Output:
%   fs - the filtered signal

% TODO: improve help
% Updates: changed fft -> fft2 to allow for use with both vector and matrix
% inputs

% Fourier transform of the signal
Ff = fft2(f);

% cut frequencies below threshold
Ff( abs(Ff)<th ) = 0;

% invert the transform to obtain the filtered signal
fs = ifft2(Ff);

% Matlab dependencies: fft, ifft, abs
% Created 2/6/2006 Jori