function o=fourier_vort(x,y,u,v)
% Calculate vorticity from velocity using the FFT
%
% Usage:
%   o=fourier_vort(x,y,u,v);
% Calculate the vorticity from the velocity
% using the Fourier transform of the fields

% TODO: clean code, improve help

N = size(u); % size of field
Nr = N(1);Nc = N(2); % get number of rows and columns
[nk,nki] = min(N); % smallest dimension and index

[jx,jy] = meshgrid([1:Nc],[1:Nr]);
hmsk = ( (1-cos(2*pi*jx/Nc))/2 ).*( (1-cos(2*pi*jy/Nr))/2 ); % hamming-type window
%u = u.*hmsk;v = v.*hmsk; % window the input fields in physical space

% get physical size of grid

    if ~exist('x')|~exist('y');
        Lx = 1;Ly = 1;
    else
        Lx = max(x(:))-min(x(:));Ly = max(y(:))-min(y(:));
    end %if

L = [Lx Ly];
[kx,ky]=fmodes2(N,L);
k = sqrt(kx.^2 + ky.^2);
mk =max(k(:));
kc = (2/3)*mk; % cutoff wavenumber
msk = k<kc;kc;

% Hann window-type mask
hmsk=(cos( (pi/2)*(k/kc)));hmsk(hmsk<0) = 0;hmsk=hmsk/sum(hmsk(:))*Nr*Nc;
%figure;imagesc(hmsk);



Fu = fft2(u);Fv = fft2(v);
i = sqrt(-1);
%whos Fu Fv kx ky
tmp = -(i*ky.*Fu) + (i*kx.*Fv);


% ensure that the signal remains real, set highest 
% wavenumber coefficients to zero
tmp(Nr/2+1,:)=0;tmp(:,Nc/2+1)=0;

%o=real(ifft2(tmp));
%o =ifft2(tmp);
o =ifft2(tmp.*msk); % mask with 2/3 rule
%o =ifft2(tmp.*hmsk); % Hanning-type window with 2/3 rule


% 9/4/2006 Jori