function p = vort2stream(o,x,y)
% Calculate the stream function from the vorticity (using FFT2)
%
% Usage:
%   p = vort2stream(o,x,y);
%
% Calculate the stream function from the vorticity
% Uses the FFT2 function and does the calculation in Fourier space
%
%

% TODO: add option for specifying grid?
% TODO: Improve help!!

N = size(o); % size of vorticity field
Fo = fft2(o); % Fourier transform of vorticity field

if ~exist('x');
    Lx = 1;Ly = 1;
else
    Lx = max(x(:))-min(x(:));Ly = max(y(:))-min(y(:));
end %if
L = [Lx Ly];

[kx,ky] = fmodes2(N,L);
k2 = sqrt(kx.^2 + ky.^2);

Fp = - Fo./(k2+eps);

% take care of problem at the origin where kx=0 ky=0
Fp(1,1) = 0;
% this is the equivalent of subtracting an arbitrary constant -> OK.

p = ifft2(Fp); % inverse Fourier transform to get the streamfunction

% Created 8/31/2006 Jori