function c=clip(f,th)
% Clipping / Thresholding function
% Thresholds the input signal f, returning the signal
% with zeros below the threshold 
%
% Usage: c=clip(f,th)
%
%
% Inputs:
%   f - input signal to be threshold
%   th - threshold level
%
% Outputs:
%   c - clipped signal
%
% Example:
%   c = clip(randn(1,128), 1);
%
% See also: ...
%

% Copyright ----

% threshold signal based upon amplitude
% set values in f smaller than th to 0
f( (abs(f)<th) ) = 0;

c=f;

% Matlab dependencies: abs - absolute value
% Created 2/3/2006 Jori
