function M = cmom(f,p)
% Calculates the pth order central moment of the signal f
%
% Usage:
%   M = cmom(f,p);
%
% Inputs:
%   f - signal f
%   p - power of moment to caculate
%
% Outputs:
%   M - pth order central moment
%
%
% See also: CMOMRATIO, FLAT, SKEW, RMS

% Created: 1/22/2006 Jori

M = mean( ( f(:) - mean(f(:)) ).^p );

% uses built-in functions: mean