function cR = cmratio(f,p,q)
% Calculates the ratio of the centered moments of a distribution
%
% Usage:
%   cR = cmratio(f,p,q);
% Calculates the ratio of the centered moments of a distribution
% The result is normalized such that
% cR = cM^p / (cM^q)^(p/q)
%
% Inputs:
%   f - 1D signal
%   p - order of centered moment (numerator)
%   q - order of centered moment (denominator)
% Outputs:
%   cR - ratio of centered moments
%
% See also: CMOM, FLAT, SKEW, RMS

cR = cmom(f,p)/(cmom(f,q))^(p/q);

% Uses: cmom
% Matlab dependencies:
% Created 2/14/2006 Jori