function M = mom(f,p)
% Calculates the pth order moment of the input signal
%
% Usage:
% M = mom(f,p);
%
% Assumes that the signal f is uniformly sampled
%
% Inputs:
%   f - signal
%   p - pth order moment to calculate
% Outputs:
%   M - pth order moment of input signal
%
% See also: CMOM, MOM, MRATIO

% Created: 1/22/2006 Jori

M = mean(f(:).^p);

% Matlab dependencies: mean
% Created: 1/22/2006 Jori