function R = mratio(f,p,q)
% Calculates the ratio of moments of a distribution
%
% Usage:
%   R = mratio(f,p,q);
%
% The result is normalized such that R = M^p / (M^q)^(p/q)
%
% Inputs:
%   f - 1D signal
%   p - order of centered moment (numerator)
%   q - order of centered moment (denominator)
%
% Outputs:
%   R - ratio of moments
%
% See also: MOM, CMOM, CMRATIO

R = mom(f,p)/(mom(f,q))^(p/q);

% Uses: mom
% Matlab dependencies:
% Created 2/14/2006 Jori