function ent = nent(X)
% Calculate the 'entropy', E, of the input signal, X
%
% Usage:
%   Entropy = nent(X);
%
% Inputs:
%   X - input signal
%
% Outputs:
%   Entropy - entropy
%
% E = - SUM ( X.^2/sum(X.^2) .* log (X.^2/sum(X.^2)) )
%
% See also: ...

%tmp1 = X.^2;
tmp1 = X.*conj(X);
tmpsum = sum(tmp1(:));
%tmpsum = sum(tmp1(:))/length(X(:));

%pk = X.^2/tmpsum;
pk = tmp1/tmpsum;


%tmp2 = pk.*log(1./(pk+eps));
tmp2 = - pk.*log((pk+eps));


ent = sum(tmp2(:));