function r = rms(f)
% Calculates the root mean square (RMS) of the input signal
%
% rms = sqrt(<f^2>)
%
% Usage:
%   r = rms(f);
%
% Inputs:
%   f - 1D signal
% Outputs:
%   r - RMS of the input signal
%
% See also KURT, FLAT, SKEW, 

% N = length(f(:)); % number of elements in signal f
% 
% r = sqrt( sum(f(:).^2) / N );
% uses built-in functions: length, sum, sqrt

% or only one line, two functions

r = sqrt( mean (f(:).^2) );

% Matlab dependencies: mean, sqrt
% Created: 1/22/2006 Jori