function f_struct=fonction_structure(f,p)
% Calculates the structure function, order p of the input signal
%
% Cette fonction calcule la fonction de structure d'ordre p du signal f
%
%
% Usage:
%   f_struct=fonction_structure(f,p)
%
% Inputs:
%   f - input signal
%   p - order of the structure function to compute
%
% Outputs:
%   f_struct - pth order structure function of the input signal
%
% Cr par Michele Caldoro, Marie Farge et Antonio Merulla
% 2002 Ecole Normale Suprieure de Paris
%

% TODO: ***Needs cleaning / fixing

n=length(f);
for l=1:(n/2-1);
   temp=0;
   for x=1:n; 
      temp=temp+(f(mod(x+l,n)+1)-f(x)).^p;
   end
   f_struct(l)=temp/n;
   fprintf('%d\n',l)
end

% Cr par Michele Caldoro, Marie Farge et Antonio Merulla
% 2002 Ecole Normale Suprieure de Paris