function I_lx = intfactor1D(wc,sc)
% 1D Intermittency factor calculated from the 1D CWT coefficients
%
% Usage:
%   I_lx = intfactor1D(wc,sc);
%
% Inputs:
%   wc - 1D CWT wavelet coefficients
%   sc - dilation parameters
%
% Outputs:
%    I_lx - intermittency factor
%

% Local intermittency factor
%%%% in 1D
f2 = wc.*conj(wc);

dnm = mean(f2,2); % integrate over space for normalization at given scale

I_lx = zeros(size(f2)); % initialize intermittency factor variable

for i = 1:length(sc); % calculate as a function of scale
       I_lx(i,:) = f2(i,:)/dnm(i);
end %i


% Created 10/20/2006 Jori
% Code cleaned up 11/08/2012 RNVY
