function I_lx = intfactor2D(wc,x,as)
%INTFACTOR2D 2D Intermittency factor calculated from 2D CWT coefficients
%
% Usage:
%   I_lx = intfactor2D(wc,x,as);
%
% Inputs:
%   wc - 2D CWT wavelet coefficients
%   x - linear position
%   as - dilation parameters
%
% Outputs:
%    I_lx - intermittency factor
%
% See also: CWT2D

y=x;
f2 = wc.*conj(wc);%whos wc f2;
clear wc; % free up memory 

dnm = mean(mean(f2,3),2); % normalization

I_lx = zeros([size(f2)]); % initialize intermittency factor variable
 
for i = 1:length(as); % calculate as a function of scale
    l = as(i); % current 'scale'
    I_lx(i,:,:) = f2(i,:,:)/dnm(i);
end %i

end

% Created 5/10/2006 Jori
% Code cleaned up 11/08/2012 RNVY
