function p = drawCWT2D(mod2D,sc,th)
% Draw the coefficients of the 2D CWT (needs improvement)
%
% Usage:
%   drawCWT2D(wc,as,th);
%
%
% Inputs:
%   wc - 2D wavelet coefficients
%   as - dilation parameters use in the CWT
%   th - threshold levels for isosurface plot
%
% Outputs:
%   p - handles to patch objects plotted as the isosurfaces
%   Creates a plot of the phase and modulus of the coefficients
%   using the pcolor function

N = size(mod2D,1);
xs = [0:N - 1]*(1/N); % periodic domain from [0,1)

nscales = length(sc);

% load config file
wavelet_toolbox_config;

ks = kpsi/2/pi./sc; % the equivalent wavenumbers that the CWT is calculated at

    
nth = length(th); % number of thresholds
figure;
    for i=1:nth
       cth = th(i); % current threshold
        
       fv = isosurface(xs, xs, ks, mod2D, cth);
       p(i) = patch(fv);set(p(i),'linestyle','none');
%       isonormals(xs,xs,ks,mod2D, p(i));
       set(p(i), 'FaceColor', 'blue', 'EdgeColor', 'none');

    end %i

    tlvl = [0.9 0.6 0.3 0.1]; % transparency levels
    for i=1:length(p); % adjust properties
        alpha(p(i),tlvl(i));
    end %i
    
       view(3);
       xlabel('pos  x');ylabel('pos  y');
       zlabel('k  (1/scale)');
       
%    set(gca,'Yscale','log');
       

% Created 5/16/2006 Jori
