%ADTCFWT
function strsig = AFDTCWT(strsig, biort, qshift, nscales)

qa = qshift;
qb = fliplr(qshift);

level = strsig.level;
Jmax = strsig.Jmax;

if(level ~= 0)
    error('DTCWT implemented only starting from level 0');
end

if(nargin < 4)
    nscales = Jmax - level;
end

if(nscales == 0)
    strsig.sig = strsig.sig*(1 + 1i);
    return;
end

% First take care of the finest scale separately.
% if(isempty(strsig.topo))
%     ba = biort;
%     bb = [0 biort 0];
%     R = FWT(strsig, ba, 1);
%     I = FWT(strsig, bb, 1);
%     W = R(2:2:end) + 1i*I(2:2:end);
%     S = strsig;
%     
% else 
%     U = mixed_level_filters(biort);
%     l_U = length(U);
%     overrun = (length(biort)-2)/2;
%     J = strsig.J0;
%     b = 1;
%     biort2 = fliplr(MirrorFilt(biort));
%     W = strsig;
%     S = strsig;
%     for n = 1:size(strsig.topo,1)
%         a = b;
%         b = strsig.topo(n,1);
%         tmpsig = strsig.sig(a:b-1);
%         tmpphi = aconv(biort, tmpsig');
%         tmppsi = aconv(biort2, tmpsig');
%         tmptail = U * tmpsig(end-l_U+1:end);
%         tmpphi(end-l_U+1:end) = tmptail(1:2:end);
%         tmppsi(end-l_U+1:end) = tmptail(2:2:end); % = 0
%         
%         W.sig(a:b-1) = tmppsi;
%         S.sig(a:b-1) = tmpphi;
%     end
%     if(j <= J)
%         if(a == b_last)
%             phi{idx} = cat(1, phi{idx}, signal(a+offset:stride:b-1));
%             rem = mod(b - a - offset,stride);
%             if(rem == 0)
%                 offset = 0;
%             else
%                 offset = stride - rem;
%             end
%         else    
%             idx = idx + 1;
%             phi{idx} = signal(a:stride:b-1);
%             if(overrun)
%                toto =  zeros(2*overrun,1);
% 
%                if(a ~= 1 && topo(1,1) ~= 1)
%                    % in this case we should have stride == 1
%                    if(stride ~= 1)
%                        error('oups');
%                    end
%                    if(a-overrun > 0)
%                        toto(1:2:2*overrun) = signal(a-overrun:a-1);
%                        phi{idx} = cat(1, toto, phi{idx});
%                    else
%                        fprintf('hum\n');
%                        toto(2*overrun-(a-1)/stride+1:2:2*overrun) = signal(1:stride:a-stride);
%                        toto{idx}(1:2:2*overrun-2*a+2) = signal(end-stride*overrun-a:stride/2:end);
%                        phi{idx} = cat(1, toto, phi{idx});
%                    end
%                end
%             end
%             if(a == 1)
%                 pos_phi(idx) = 1;
%             else
%                 pos_phi(idx) = 0;
%             end
%             
%             rem = mod(b - a,stride);
%             if(rem == 0)
%                 offset = 0;
%             else
%                 offset = stride - rem;
%             end
%         end
%         b_last = b;
%     end
% 
%     offset = offset * 2^(topo(n,2));
%     J = J + topo(n,2);
% 
% end %for
% end    

%R = AFWT(strsig, ba, 1);
%I = AFWT(strsig, bb, 1);
R = AFWT(strsig, qa, nscales);
I = AFWT(strsig, qb, nscales);

strsig.sig = (R.sig + 1i*I.sig) / sqrt(2);
strsig.level = level + nscales;

end
%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
