%AIDTCWT
function strsig = AIDTCWT(strsig, biort, qshift, nscales)

qa = qshift;
qb = fliplr(qshift);
ba = biort;
bb = [0 biort 0];

level = strsig.level;
Jmax = strsig.Jmax;

if(nargin < 4)
    nscales = level;
end

if(nscales ~= level)
    error('AIDTCWT implemented only to level 0');
end

R = strsig;
I = strsig;
R.sig = real(strsig.sig);
I.sig = imag(strsig.sig);

R = AIWT(R, qa, nscales);
I = AIWT(I, qb, nscales);

strsig.sig = (R.sig + I.sig) / sqrt(2);
strsig.level = level - nscales;

end
%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
