%AIDTCWT_PRIME
function strsig = AIDTCWT_prime(strsig, biort, qshift, nscales)

qa = qshift;
qb = fliplr(qshift);

level = strsig.level;

if(nargin < 4)
    nscales = level;
end

if(nscales ~= level)
    error('AIDTCWT implemented only to level 0');
end

R = strsig;
I = strsig;
R.sig = real(strsig.sig);
I.sig = imag(strsig.sig);

R = AIWT(R, qa, nscales-1);
I = AIWT(I, qb, nscales-1);

ba = conv(deconv(biort, [1 1]), [1 -1]);
bb = [0 ba 0];
ba_tilde = 0*ba;
bb_tilde = 0*bb;

R = AIWT(R, ba, 1, ba_tilde);
I = AIWT(I, bb, 1, bb_tilde);

strsig.sig = (R.sig + I.sig) / sqrt(2);
strsig.sig = circshift(strsig.sig, [0 -1]);
strsig.level = level - nscales;

end
%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
