%FWT
function strsig = FWT(strsig, qmf, nscales)

level = strsig.level;
sig = strsig.sig;
g = qmf ;
h = fliplr(MirrorFilt(g));

if(nargin < 3)
    [N,J] = dyadlength(sig);
    nscales = J-level;
end
    

for l = level:level+nscales-1
   
    phi = sig(1:2^l:end);
    
    tmp_phi = aconv(g,phi);
    tmp_psi = aconv(h,phi);

    sig(1:2^(l+1):end) = tmp_phi(1:2:end);
    sig(1+2^(l):2^(l+1):end) = tmp_psi(1:2:end);
end %for

strsig.sig = sig;
strsig.level = level + nscales;

end %function
%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
