%
function idx4 = cluster_zones(idx, G, topo1)
% this function will add elements in each component of idx
% so that :
% each sequence of consecutive elements has a leat G elements, and the
% number of elements is even
% two sequences of consecutive elements are separated by at least G
% elements

for n = 1:length(idx)
    
    if(isempty(idx{n}))
        idx4{n} = {};
        continue;
    end
    idx2{n} = idx{n};
    d = diff(idx{n});
    holes = find((d >= 2));

    for h = 1:length(holes)
        tail = idx{n}(holes(h)+1);
        idx2{n} = union(idx2{n},tail+1:tail+G);
    end

    idx2{n} = union(idx2{n},idx{n}(1):idx{n}(1)+G-1);

    idx3{n} = idx2{n};
    d = diff(idx2{n});
    holes = find((d >= 2) & (d <= G));

    for h = 1:length(holes)
        idx3{n} = union(idx3{n}, idx2{n}(holes(h))+1:idx2{n}(holes(h)+1));
    end

    in = diff(diff(idx3{n}) == 1);
    start = [1 find(in == 1)+1];
    stop  = [find(in == -1)+1 numel(idx3{n})];

    idx4{n} = cell(length(start),1);
 
    for i = 1:length(start)
        a = 4*floor((idx3{n}(start(i))-1)/4)+1;
        b = 4*ceil((idx3{n}(stop(i)))/4);
        if(n == 1)
            a = max([a, 1]);
            if(~isempty(topo1))
                b = min([b, topo1(1)-1]);
            end
        else
            a = max([a, topo1(n-1)]);
            if(length(topo1) >= n)
                b = min([b, topo1(n)-1]);
            end
        end
        idx4{n}{i} = [a b];
    end

end

end
%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
