%CONVERT_TO_INTERVALS
function interv = convert_to_intervals(idx)

interv = zeros(0,2);

for n = 1:length(idx)
    
    if(isempty(idx{n}))
        continue;
    end

    d = diff(idx{n});
    
    istart = 1;
    
    while(1)
        next_hole = istart-1+find((d(istart:end) ~= 1),1);
        if(isempty(next_hole))
            interv = cat(1, interv, [idx{n}(istart) idx{n}(end)]);            
            break;
        end
        interv = cat(1, interv, [idx{n}(istart) idx{n}(next_hole)]);
        istart = next_hole+1;

    end
   
end


end
%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
