%DISTRIBUTE_ZONES
function idx = distribute_zones(idx_in, topo)
% topo : grid descriptor
% idx_in : indices
% idx : cell array containing all the indices in idx_in but split between
% zones

if(isempty(topo))
    idx{1} = idx_in;
    return;
end

idx{1} = idx_in(idx_in < topo(1,1));

for n = 1:size(topo, 1)-1
    idx{n+1} = idx_in((idx_in >= topo(n,1)) & (idx_in < topo(n+1,1)));
end

idx{end+1} = idx_in(idx_in >= topo(end,1));

end

%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
