%% First tests to compute mixed-level filters.
function [U] = mixed_level_filters2(g)

%g = MakeONFilter('Daubechies', 6);
%g = 1:6;
G = length(g);
h = fliplr((-1).^(0:G-1).*g);
%h = 11:16;

even = g;
even(1:2:G) = h(1:2:end);
even(2:2:G) = g(1:2:end);

odd = g;
odd(1:2:G) = h(2:2:end);
odd(2:2:G) = g(2:2:end);

L1 = zeros(G-2, G-2);
R1 = zeros(G-2, G-2);

L2 = zeros(G-2, G-2);
R2 = zeros(G-2, G-2);


for i = 1:2:G-2
L1(i, i:end) = g(1:end-i-1);
L2(i, i:end) = even(end:-1:i+2);

R1(i, 1:i+1) = g(end-i:end);
R2(i, 1:i+1) = even(i+1:-1:1);

end

for i = 2:2:G-2
    
L1(i, i-1:end) = h(1:end-i);
L2(i, i-1:end) = odd(end:-1:i+1);

R1(i, 1:i) = h(end-i+1:end);
R2(i, 1:i) = odd(i:-1:1);

end

%I = eye(G-2,G-2);

% On a L1*R2*X1 = L1*Y1
B1 = cat(1, L1, zeros((G-2)/2, G-2)) ;
%B1 = cat(2, B1, zeros((G-2)/2, G-2+(G-2)/2)') 
alt = eye(G-2, G-2);
alt = alt(2:2:end, :);
A1 = cat(1, L1*R2, alt);
%A1 = cat(2, A1, ((eye((G-2)/2, G-2+(G-2)/2)')));
%B2 = [I-L1*R2-R1*L2, -R2];
%B = blkdiag(B1,B2);
%A = [;L1*L2];

U = A1 \ B1;
%V = A2 \ B2;

end

%%

% [V1,D1] = eig(A1);
% 
% I1 = V1(:,G/2:end);
% K1 =  V1(:,1:G/2-1);
% S1 = I1 \ B1; % solution particuliere
% 
%  A2 = R2*L1;
%  B2 =  R2;
% % 
%  [V2,D2] = eig(A2);
% % 
%  I2 = V2(:,G/2:end);
%  K2 =  V2(:,1:G/2-1);
%  S2 = I2 \ B2; % solution particuliere
% 
% A = [K1'*K1, - K1'*R1*K2 ; -K2'*L2*K1, K2'*K2];
% B = [0*K1'*K1, K1'*L1; K2'*R2, 0*K1'*K1];
% 
% [V,D] = eig(A);
% 
% R2bar = R2(:,1:2:end);



%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
