%% Compute moments of a scaling function
function m = scaling_function_moments(qmf, n)

m = zeros(1,n);
S = length(qmf);

m(1) = 1;
for k = 1:n
   m(k+1) = 1./(sqrt(2)*(2^k-1))*sum(sum( repmat(qmf(:),[1 k]) .* repmat(binom(k, 1:k) .* m(k:-1:1), [S 1]) .* cumprod(repmat((0:S-1)',[1 k]),2) ));
end

end
%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
