%SET_ADAPTIVE_PHI Changes scaling function coefficients based on tree descriptor
function strsig = set_adaptive_phi(phi, strsig, j)

J = strsig.J0;
b = 1;
signal = strsig.sig(:);
idx = 0;
b_last = 0;
offset = 0;
phipos = 1;

for n = 1:size(strsig.topo,1)
    a = b;
    b = strsig.topo(n,1);
    stride = 2^(J-j);
    
    if(j <= J)
        if(a == b_last)
%            phi{idx} = cat(1, phi{idx}, signal(a+offset:stride:b-1));
            ncoefs = numel(signal(a+offset:stride:b-1));
            signal(a+offset:stride:b-1) = phi{idx}(phipos:phipos+ncoefs-1);
            phipos = phipos + ncoefs;
            rem = mod(b - a - offset,stride);
            if(rem == 0)
                offset = 0;
            else
                offset = stride - rem;
            end
        else    
            idx = idx + 1;
            phipos = 1;
%            phi{idx} = signal(a:stride:b-1);
            ncoefs = numel(signal(a:stride:b-1));
            signal(a:stride:b-1) = phi{idx}(phipos:phipos+ncoefs-1);
            phipos = phipos + ncoefs;
            rem = mod(b - a,stride);
            if(rem == 0)
                offset = 0;
            else
                offset = stride - rem;
            end
        end
        b_last = b;
    end

    offset = offset * 2^(strsig.topo(n,2));
    J = J + strsig.topo(n,2);

end %for

if(j <= J)
    stride = 2^(J-j);
    if(b == b_last)
        %        phi{idx} = cat(1, phi{idx}, signal(b+offset:2^(J-j):end));
        signal(b+offset:stride:end) = phi{idx}(phipos:end);
    else
        idx = idx + 1;
        %        phi{idx} = signal(b:2^(J-j):end);
        if(numel(signal(b:stride:end)) ~= numel(phi{idx}))
            fprintf('oups\n');
        end
        signal(b:stride:end) = phi{idx};
    end
end

strsig.sig = signal;

end
%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
