%IWT
function strsig = IWT(strsig, qmf, nscales)

level = strsig.level;
sig = strsig.sig;
g = qmf;
h = fliplr(MirrorFilt(g));

even = h;
odd = g;
even(2:2:end) = g(1:2:end);
odd(1:2:end) = h(2:2:end);

if(nargin < 3)
   nscales = level;
end

for l = level-1:-1:level-nscales

    phipsi = sig(1:2^(l):end);

    tmp_even = fliplr(aconv((even),fliplr(phipsi)));
    tmp_odd =  fliplr(aconv((odd),fliplr(phipsi)));

    sig(1:2^(l+1):end)  = tmp_even(2:2:end);
    sig(1+2^(l):2^(l+1):end) = tmp_odd(2:2:end);

end %for

strsig.sig = sig;
strsig.level = level - nscales;

end %function
%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
