%MAKE_AWT_GRID
function [grid, iphi, jphi] = make_awt_grid(strsig)

J = strsig.J0;
b = 1;
topo = strsig.topo;

phipos = 0;
iphi = [];
jphi = [];

for n = 1:size(topo,1)
    a = b;
    b = topo(n,1);
    
    new_phi = phipos + (0:b-a-1);

    phipos = phipos + numel(new_phi);   
    iphi = [iphi new_phi];
    jphi = [jphi J*ones(1,numel(new_phi))];
  
    J = J + topo(n,2);
    phipos = phipos * 2^(topo(n,2));
    
end %for
    
new_phi = phipos + (0:numel(strsig.sig(b:end))-1);    
iphi = [iphi new_phi];
jphi = [jphi J*ones(1,numel(new_phi))];

grid = (iphi+1) ./ (2.^(jphi+strsig.Jmax-strsig.J0));

end

%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
