%PLOT_AWT_TREE
function plot_awt_tree(strsig)

%level = 1;
Jmax = strsig.Jmax;
level = 0;

% First plot the scaling function coefficients
[grid, iphi, jphi] = make_awt_grid(strsig);

% Then plot the wavelet coefficients
level = level + 1;
ipsi = [];
jpsi = [];
%treepsi = [];

while(level <= strsig.level)
    B = (jphi == Jmax - level + 1);
    iout = iphi(B);
    iphi = iphi(~B);
    jphi = jphi(~B);
    
    % we need to insert iphi at a proper place
    deltai = iphi(jphi == Jmax-level);
    deltaj = jphi(jphi == Jmax-level);
    tmpi = iphi(jphi ~= Jmax-level);
    tmpj = jphi(jphi ~= Jmax-level);
    
    deltai = [deltai (iout(1:2:end)/2)];
    deltaj = [deltaj (Jmax-level)*ones(1,sum(B)/2)]; 
    
    [deltai, S] = sort(deltai);
    deltaj = deltaj(S);
    
    iphi = [deltai tmpi];
    jphi = [deltaj tmpj];
    
%    [iphi, S] = sort(iphi);
%    jphi = jphi(S);
    
    ipsi = [ipsi (iout(1:2:end)/2)];
    jpsi = [jpsi (Jmax-level)*ones(1,sum(B)/2)]; 

    level = level + 1;
end
figure;
plot(ipsi ./ 2.^(jpsi), jpsi, 'rx');
hold all;
ylabel('dyad');
xlabel('position');
plot(iphi ./ 2.^(jphi), 0*iphi, 'b+');
title(sprintf('level = %i, Jmax = %i, Ncoefs = %i, ntopo = %i', strsig.level, strsig.Jmax, numel(strsig.sig), size(strsig.topo, 1)));
box on;
hold all;

end

%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
