%% Compute the derivative adaptively using wavelets...

%% Construct the derivative filter
%load('dtcwt_1D-2D/qshift_b');
%g = (g0a');
g = MakeONFilter('Daubechies',12);
G = length(g);
h = fliplr((-1).^(0:G-1).*g);
%hp = 0*h;
D = @(f) deconv(conv(f,[1/2 -1/2]),[1 1]);
gp = D(g) + D(D(D(g)))/4;
%hp = fliplr((-1).^(0:G-1).*gp);
hp = 0*gp;
%hp = deconv(conv(h,[1 1]),[1/2 -1/2]);

%gp = fliplr(gp);

%% Construct the descending edge matrix
even = h;
even(1:2:G) = h(1:2:end);
even(2:2:G) = g(1:2:end);

odd = g;
odd(1:2:G) = h(2:2:end);
odd(2:2:G) = g(2:2:end);

evenp = hp;
evenp(1:2:G) = hp(1:2:end);
evenp(2:2:G) = gp(1:2:end);

oddp = gp;
oddp(1:2:G) = hp(2:2:end);
oddp(2:2:G) = gp(2:2:end);

[L1,R1,L2,L2p,R2,R2p] = deal(zeros(G-2));

for i = 1:2:G-2
    L1(i, i:end) = g(1:end-i-1);
    L2(i, i:end) = even(end:-1:i+2);
    L2p(i, i:end) = evenp(end:-1:i+2);

    R1(i, 1:i+1) = g(end-i:end);
    R2(i, 1:i+1) = even(i+1:-1:1);
    R2p(i,1:i+1) = evenp(i+1:-1:1);
end

for i = 2:2:G-2
    L1(i, i-1:end) = h(1:end-i);
    L2(i, i-1:end) = odd(end:-1:i+1);
    L2p(i, i-1:end) = oddp(end:-1:i+1);
    
    R1(i, 1:i) = h(end-i+1:end);
    R2(i, 1:i) = odd(i:-1:1);
    R2p(i, 1:i) = oddp(i:-1:1);
end

%L2p = L2p/2;
%R2p = R2p/2;
% normal mixed level filters matrix
B1 = cat(1, L1, zeros((G-2)/2, G-2)) ;
alt = eye(G-2, G-2);
alt = alt(2:2:end, :);
A1 = cat(1, L1*R2, alt);
U = A1 \ B1;

% derivative on the right side of a HRZ
Ul = zeros(size(U,1),2*size(U,2));
Ul(:,1:2:end) = U;
Md = cat(2, L2p*Ul, R2p) ;

% derivative on the left side of a HRZ
M2 = [L2,R2];
ix = (G-2)/2-mod((G-2)/2,2);
%ix = 2;
M2 = M2((G-2)/2+1:end,ix+1:end);
M2l = zeros(G-2,2*(G-2)-ix);
M2l(1:2:end,:) = M2;
Mg = [L2p*M2l, R2p];


%%
M = 16;
F.topo = [8*M+1,1;(8+32)*M+1,-1;64*M+1,-1;(64+16)*M+1,1];
F.level = 0;
F.Jmax = log2(128*M);
F.J0 = log2(128*M)-1;
F.sig = zeros(128*M,1);
x = make_awt_grid(F);
F.sig = exp(-100*(x-0.5).^2);
qmf = g;

F_t = AFWT(AIWT(AFWT(grid_to_wt(F),qmf),qmf),qmf);
F2_t = F_t;
F2_t.sig = F2_t.sig(1:2:end);
F2_t.level = F.Jmax - 1; 
F2_t.Jmax = F.Jmax - 1; 
F2_t.J0 = F.J0 - 1;
F2_t.topo(:,1) = (F2_t.topo(:,1)-1)/2 + 1;
F2_r = AIWT(F2_t,qmf);
F2_g = wt_to_grid(F2_r);
x2 = make_awt_grid(F2_g);

F3_t = F_t;
F3_t.sig(:) = 0;% = F_t.sig;
F3_t.sig(1:2:end) = F2_r.sig;
toto = F3_t.sig;
titi = (iconv(gp,toto'));
titi(64*M+1:64*M+1+9) = (Md)*toto(64*M+1+9-29:64*M+1+9);
titi((64+16)*M+1:(64+16)*M+1+9) = Mg*toto((64+16)*M+1+9-25:(64+16)*M+1+9);
titi(8*M+1:8*M+1+9) = Mg*toto(8*M+1+9-25:8*M+1+9);
titi((8+32)*M+1:(8+32)*M+1+9) = Md*toto((8+32)*M+1+9-29:(8+32)*M+1+9);
F3_r = F3_t;
F3_r.level = 0;
F3_r.sig = titi;
F3_g = wt_to_grid(F3_r);
F3_g.sig(8*M+1:(8+32)*M) = F3_g.sig(8*M+1:(8+32)*M)*2;
F3_g.sig(1:64*M) = F3_g.sig(1:64*M)*2;
F3_g.sig((64+16)*M+1:end) = F3_g.sig((64+16)*M+1:end)*2;
plot(x,F3_g.sig,'b.-');

F4_t = AFWT(grid_to_wt(F3_g),qmf);
F4_r = AIWT(F4_t,qmf);
F4_g = wt_to_grid(F4_r);
%hold all;plot(x,F4_g.sig);



%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
