%% Test analytic formula
biort = 'antonini';
qshift = 'qshift_32';
J = 7:14;
for i=1:length(J);
N = 2^J(i);
x = -1+1/N:2/N:1;
F = exp(-50*x.^2)';
G = -100.*x'.*F;

[Fl, Fh] =  dtwavexfm(F, 1, biort, qshift);
Fh{1}(:) = 0;
G_r = N*dtwaveifm(Fl,Fh, 'derivating_antonini', 'qshift_d');
F_r = dtwaveifm(Fl,Fh, 'antonini', 'qshift_d');

err1(i) = sqrt(l2d2(F_r, F)*2/N);
err2(i) = sqrt(l2d2(G_r, G)*2/N);
G2 = diff(F)*N/2;
err3(i) = sqrt(l2d2(G2, G(2:end))*2/N);

end

%figure;
%plot(x, -N*N*(F-Fl));
%hold all;
%plot(x, -100*(1-100*x'.^2).*F);

ant = load('antonini');
M = 2^10;
y = zeros(1,M);
k = [0:(M/2-1) 0 -M/2+1:-1];
%k = fmodes(M);
y(end-2:end) = ant.g0o(1:3);
y(1:4) = ant.g0o(4:end);
dd = sqrt(pi/2)*ifft(pi*1i/M .* k .* fft(y), 'symmetric');
K = 51;
df = zeros(1,K);
df(1:floor(K/2)) = dd(end-(floor(K/2)-1):end);
df(ceil(K/2):end) = dd(1:ceil(K/2));
g0o = df;
g1o = 0;
save dtcwt_1D-2D/derivating_antonini.mat g0o g1o;

g0o = ant.g0o;
t = deconv(g0o, [1 1]);
g0o = conv(t, [1 -1]);
save dtcwt_1D-2D/derivating2_antonini.mat g0o g1o;



%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
