function G = g_f(n,type)
%G_F Internal routine for computing quadrature mirror filters for the Shannon and Meyer wavelet.

% Version 1.0 Rodrigo Pereira & RNVY 2010-2012

ks = ifftshift([-n/2:n/2-1])/n;

% Generic computation for QMF
H = h_f(n,type);
G = conj(circshift(H,[1 n/2])) .* exp(-2*1i*pi*ks);

end

%  This file is part of the ENS Wavelet Toolbox 
%  Copyright (C) 2006-2012 LMD-ENS-CNRS-Universite Paris 11 - Romain Nguyen van yen, Rodrigo Pereira, Jori Ruppert-Felsot
%  This program is free software: you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  (at your option) any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License for more details.
%
%  You should have received a copy of the GNU General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
