function PaletteMarie = PaletteMarie(Type,taille,limite_faible_fort,etalement_du_zero)

% PaletteMarie(Type,taille,limite_faible_fort,etalement_du_zero)
%
% taille = size
% limite_faible_fort = limit of strong and weak vorticity
% etalement_du_zero = zero spreadding
%
% Where Type is : 'Vorticite'

     
if strcmp(Type,'Vorticite')
     color1=[0 0 1];
     color2=[1 1 1];
     color3=[1 0 0];
     zero=[1 1 0];

    limite_basse = floor(taille/2*(1-limite_faible_fort));
    limite_haute = ceil(taille/2*(1+limite_faible_fort));

     zero_moins = floor((taille-etalement_du_zero)/2);
     zero_plus = ceil((taille + etalement_du_zero)/2);

PaletteMarie = [ linspace(0,1,limite_basse)'*color1; linspace(0,0.5,zero_moins-limite_basse)'*color2; ones(etalement_du_zero,1)*zero; linspace(0.5,1,limite_haute-zero_plus)'*color2; linspace(0,1,taille-limite_haute)'*color3 ];
end 

if strcmp(Type,'Vorticite2') % modified Marie's original palette to account for non-symmetric (about zero) fields 
     color1=[0 0 1];
     color2=[1 1 1];
     color3=[1 0 0];
     zero=[1 1 0];

     f2 = 10;% maximum
     f1 = -5; % minimum
     fz = 0; % zero
     %L = 2; % limit of small magnitude values around fz (zero)
     L = limite_faible_fort; % limit of small magnitude values around fz (zero)

     zero_moins = floor( abs(fz - L)/(f2-f1) * taille ) - etalement_du_zero;
     zero_plus =  floor( abs(fz - L)/(f2-f1) * taille ) - etalement_du_zero;

     
     limite_basse = floor( (fz-f1)/(f2-f1) * taille) - etalement_du_zero - zero_moins;
     limite_haute = ceil( (f2- (fz) )/(f2-f1) * taille) - etalement_du_zero - zero_plus;
     
     
PaletteMarie = [ linspace(0,1,limite_basse)'*color1; linspace(0,0.5,zero_moins)'*color2; ones(etalement_du_zero,1)*zero; linspace(0.5,1,zero_plus)'*color2; linspace(0,1,limite_haute)'*color3 ];
end 


if strcmp(Type,'CWT_MORLET_CUM')
     color1=[0 0 1];
     color2=[0 1 0];
     color3=[1 0 0];
     zero=[1 1 0];


     limite_basse = floor(taille/2*(1-limite_faible_fort));
     limite_haute = ceil(taille/2*(1+limite_faible_fort));

     zero_moins = floor((taille-etalement_du_zero)/2);
     zero_plus = ceil((taille + etalement_du_zero)/2);

PaletteMarie = 1 - [ abs(linspace(-1,1,2*limite_haute))'*[1 1 1] ].^2;

%PaletteMarie = [ abs(linspace(-1,1,2*limite_haute))'*color3 ].^1  + [ abs(linspace(-1,1,2*limite_haute))'*color2 ].^2 ;
end
