% Make plots of the complex Morlet wavelet
clear all;close all;

J = 10;N = 2^J; % number of sample points

    k_0 = 6;     % frequency of Morlet wavelet
    x_0 = 0.5; % position of wavelet (in center of domain)    
    L = 1/16; % select arbitrary scale of wavelet for display
sc = L;

    % generate the complex Morlet wavelet
%     [wp,x] = make_physical_morlet(N,L,k_0,x_0);
%     fwp = fft(wp)/N;
%     % **note that this physical space representation is not periodized    

    [wp,x] = gen_cmorlet(N,sc,'p');
    [fwp,k] = gen_cmorlet(N,sc,'f');

%     % prepare frequencies for plot of Fourier transform (FFT) of the wavelet
%         k = [1:N/2-1];
%         k = [0 k N/2 -fliplr(k)];
%         delta = 1/N; % use dx from finer grid??
%         fk = k/N/delta; % real frequencies
%     % note that the interval here is [0,1)
        
    
% plot the real and imaginary components of the wavelet
    plot(x,imag(wp),'--b');hold on;
    plot(x,real(wp),'k');
    plot(x,abs(wp),'m');plot(x,-abs(wp),'m');
    xlabel('position x');legend('Real','Imaginary');
    title(['Morlet: k_0 = ',num2str(k_0),'; a = 1/',num2str(1/L)]);
    print('-depsc2',['cmorl_k',num2str(k_0),'_a',num2str(1/L),'.eps']);

% plot the modulus of the FFT
    figure;
    plot(k,abs(fwp),'-k');hold on;
    xlabel('wave number k');
    title(['abs(FFT(Morlet)): k_0 = ',num2str(k_0),'; a = 1/',num2str(1/L)]);
    axis([-N/2 N/2 0 0.8]);
    print('-depsc2',['cmorl_absFFT_k',num2str(k_0),'_a',num2str(1/L),'.eps']);
    
    
    % change the scale
    x_0 = 0.6;x_0=0.1;
%    Ls = 1./[8 16 32 64 128];
    Ls = 1./[1 2 4 8 16];
    for i=1:length(Ls)
        L = Ls(i);
        
        % calculate the wavelet and its FFT
%         [wp,x] = make_physical_morlet(N,L,k_0,x_0-i*0.1);
%         fwp = fft(wp)/N;

        [wp,x] = gen_cmorlet(N,cwscale(L,'sc2a'),'p');
        [fwp,k] = gen_cmorlet(N,cwscale(L,'sc2a'),'f');
        
        % plot the real components of the wavelet
        figure(6);
        plot(x-(i-1)*0.1,ifftshift(abs(wp))+i*12,'--m');hold on;
        plot(x-(i-1)*0.1,-ifftshift(abs(wp))+i*12,'--m');
        plot(x-(i-1)*0.1,ifftshift(real(wp))+i*12,'-k');
        text(x_0-(i-1)*0.12,i*12+5,['L = 1/',num2str(1/L)]);
        
        % plot the modulus of the FFT
            figure(7);
            plot(k,abs(fwp),'-k');hold on;
            text(0+(cwscale(L,'sc2k')),0.9-i*0.15,['L = 1/',num2str(1/L),sprintf('\n'),'k = ',num2str(cwscale(L,'sc2k'),'%0.1f')]);
    end %i, loop over Ls
    figure(6); % physical space plot
    xlabel('position x');title('Physical space complex Morlet');
%    axis([0 1 0 75]);
    axis([-0.5 0.5 0 75]);
    print('-depsc2','cmorl_as.eps');
    figure(7); % Fourier space plot
    xlabel('wavenumber k');title('FFT(complex Morlet)');
    axis([0 200 0 0.9]);
    print('-depsc2','cmorl_FFT_as.eps');
    
    %            print('-depsc2',['cmorl_absFFT_k',num2str(k_0),'_L',num2str(1/L),'.eps']);

            %            xlabel('wave number k');
%            title(['abs(FFT(Morlet)): k_0 = ',num2str(k_0),'; L = 1/',num2str(1/L)]);
%            axis([-N/2 N/2 0 0.8]);
    

            
    
% Created 4/26/2006 Jori