% Plot the various scales associated with the wavelets

clear all;close all;

J = 10; % number of octaves
N = 2^J; % number of sample points in the signal
Jmax = J; % octave to stop the decomposition
nv = 8; % number of voices per octave, sampling for reconstruction
sc = 2.^-([0:(Jmax*nv)]/nv); % scales at which to perform the transform



    xs = [0:N - 1]*(1/N); % periodic domain from [0,1)

    
%    kc = kp/2/pi/a; 
    
    k_0 = 5; % Morlet wavenumber
    
    as = linspace(eps,1,10000); % the dilation parameters
    x0 = 0.5; % evaluate at the center of the domain
    

    mos = ( exp(i*k_0*(x0./as)) - exp(-k_0^2/2) ) .* exp(-(x0./as).^2/2);
    mos = abs( (1./sqrt(as)).*mos ); % renormalize due to scale change

    figure(1);
    plot(as,mos);
    %loglog(as,mos);
    %semilogy(as,mos);
    xlabel('Dilation parameter a');ylabel('Modulus of wavelet at center of domain');
    print('-depsc2','cmorl_mod_a.eps');
    
    
%    % generate the wavelet
%    [wf,k] = gen_cmorlet(N,a,'f');
    
% plot a few wavelets for different dilation parameters    


% find index of dilation just at the threshold
th = [10^-1 10^-3 10^-6 10^-9 10^-12];

for J=1:length(th)
    
    in = mos < th(J);
    ta = as(in);ta = ta(end);

% calculate the wavelet at the given dilation
    tmo = ( exp(i*k_0*(xs./ta)) - exp(-k_0^2/2) ) .* exp(-(xs./ta).^2/2);
    mo(:,J) = abs( (1./sqrt(ta)).*tmo ); % renormalize due to scale change

    legcell{J} = num2str(th(J)); % legend entries
end %J
% Now plot
    figure(2);
    plot(xs,abs(mo));hold on;
    xlabel('position x');ylabel('Modulus of wavelet');
    title('Complex Morlet');
        legend(legcell);
% put text on graph later...
        print('-depsc2','cmorl_mod_th.eps');

    in = mos < 10^-3;
    ta = as(in);ta = ta(end);
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % plot several wavelet scales  
    figure(3);
    ls = [1 1/2 1/4 1/16];
    for J=1:length(ls);    
        l = ls(J);
        [wp(:,J),x] = gen_cmorlet(N,l,'p');
        [wf(:,J),k] = gen_cmorlet(N,l,'f');    
        legcell{J} = ['1/',num2str(1/l)];
    end %J
    %        plot(x,abs(ifft(wf)*N));hold on;pause;
        plot(xs,abs((wp)));hold on;
    xlabel('position x');ylabel('Modulus of wavelet');
    title('Complex Morlet');
            legend(legcell);
print('-depsc2','cmorl_scales1.eps');

            % plot the value of the FFT of the complex Morlet at the 
            % highest frequency (k=N/2) as a function of scale
        

            
        sc = linspace(10^-5,1,10000); % scales    
        as = 0.1254*sc; % dilation parameters

        kmax = N/2; % evaluate at maximum wavenumber (frequency)
        k_0 = 5; % evaluate for our standard k_0 = 5 morlet

        fmos = sqrt(2*pi)*( exp(-(2*pi*(as*kmax)-k_0).^2/2) - exp(-k_0^2/2)*exp(-(2*pi*(as*kmax)).^2/2) );
        fmos = sqrt(as).*fmos;        % renormalize due to change in scale

        
        
        
        figure(4);
        %loglog(sc,fmos);
        semilogy(1./sc,fmos);        
        xlabel('1 / Wavelet scale');ylabel('Modulus of FFT wavelet at maximum frequency');
        axis([0 64 10^-10 10^-1]);

        axes('position',[0.225 0.45 0.4 0.4]);
        plot(1./sc,fmos);
        axis([0 64 0 0.06]);
        print('-depsc2','cmorl_absFFT_maxk.eps');
%     
          
            
            
% Created 4/28/2006 Jori